*** asterisk.c	18 Jul 2004 18:52:36 -0000	1.107
--- asterisk.c	30 Jul 2004 07:51:27 -0000
***************
*** 619,624 ****
--- 617,640 ----
  	quit_handler(num, 0, 1, 0);
  }
  
+ static void remote_quit_handler(int num)
+ {
+ 	char filename[80] = "";
+ 
+ 	if (getenv("HOME")) 
+ 		snprintf(filename, sizeof(filename), "%s/.asterisk_history", getenv("HOME"));
+ 	if (!ast_strlen_zero(filename)) {
+ 		printf("Saving history\n");
+ 		ast_el_write_history(filename);
+ 	}
+ 	if (el != NULL)
+ 		el_end(el);
+ 	if (el_hist != NULL)
+ 		history_end(el_hist);
+ 	printf(term_quit());
+ 	exit(0);
+ }
+ 
  static const char *fix_header(char *outbuf, int maxout, const char *s, char *cmp)
  {
  	const char *c;
***************
*** 1353,1358 ****
--- 1379,1393 ----
  	char *ebuf;
  	int num = 0;
  
+ 	/*
+ 	 *	handle some signals in remote control mode
+ 	 */
+ 	signal (SIGINT,remote_quit_handler);
+ 	signal (SIGINT,remote_quit_handler);
+ 	signal (SIGTERM,remote_quit_handler);
+ 	signal (SIGHUP,remote_quit_handler);
+ 	signal (SIGPIPE,SIG_IGN);
+ 
  	read(ast_consock, buf, sizeof(buf));
  	if (data)
  		write(ast_consock, data, strlen(data) + 1);
